#import <UIKit/UIKit.h>

@interface HNWebViewController : UIViewController <UIWebViewDelegate> {
	UIWebView *webView;
	UIToolbar *toolbar;
	UIBarButtonItem *backButton;
	UIBarButtonItem *forwardButton;
	UIBarButtonItem *refreshButton;
	UIBarButtonItem *stopButton;
}

@property (nonatomic, retain) IBOutlet UIWebView *webView;
@property (nonatomic, retain) IBOutlet UIToolbar *toolbar;
@property (nonatomic, retain) IBOutlet UIBarButtonItem *backButton;
@property (nonatomic, retain) IBOutlet UIBarButtonItem *forwardButton;
@property (nonatomic, retain) IBOutlet UIBarButtonItem *refreshButton;
@property (nonatomic, retain) IBOutlet UIBarButtonItem *stopButton;


- (IBAction)backButtonPressed:(id)sender;
- (IBAction)forwardButtonPressed:(id)sender;
- (IBAction)refreshButtonPressed:(id)sender;
- (IBAction)stopButtonPressed:(id)sender;
- (IBAction)actionButtonPressed:(id)sender;
- (IBAction)pageDownButtonPressed:(id)sender;
- (IBAction)pageUpButtonPressed:(id)sender;

- (void)refreshButtonEnablement;
- (void)setRefreshMode:(BOOL)refreshMode;
- (void)considerReachability;
- (BOOL)connectedToNetwork;

@end

