#import "NewsCSSMuncher.h"
#import "consumption.h"

#define kFontMultiplier (1.75)
@implementation NewsCSSMuncher

- (void)reset { }

- (NSData *)finish {
	// Here we add custom stylings at the end of the stylesheet.
	static const char extraCSS[] = "body { background: black; }\n"
//	".comment { word-wrap: break-word; }\n"
	".pagetop { line-height: 24pt; }\n"
	"img[src=\"http://ycombinator.com/images/grayarrow.gif\"] { width: 20px; height: 20px; }\n"
	"img[src=\"http://ycombinator.com/images/graydown.gif\"] { width: 20px; height: 20px; }\n";
	[unparsedData appendBytes:extraCSS length:strlen(extraCSS)];
	return [super finish];
}

void consume(NSMutableData *output, const char **posRef, const char *end) {
	const char *pos = *posRef;
	const char *r = pos;
	for (;;) {
		const char *fontSize = skipThroughString(&r, end, "font-size:");
		if (fontSize) {
			const char *beforeSize = skipAnyWhitespace(r, end);
			const char *afterSize = eatToOneOf(beforeSize, end, "; }");
			if (afterSize) {
				if (afterSize - beforeSize >= 3 && afterSize[-2] == 'p' && (afterSize[-1] == 't' || afterSize[-1] == 'x')) {
					[output appendBytes:pos length:beforeSize - pos];
					pos = beforeSize;
					NSData *tmpd = [[NSData alloc] initWithBytes:beforeSize length:afterSize-beforeSize];
					NSString *tmpString = [[NSString alloc] initWithData:tmpd encoding:NSUTF8StringEncoding];
					[tmpd release];
					NSInteger size = [tmpString integerValue];
					[tmpString release];
					[output appendData:[[NSString stringWithFormat:@"%f", size*kFontMultiplier]
					                    dataUsingEncoding:NSASCIIStringEncoding]];
					pos = afterSize - 2;
					r = afterSize - 2;
				} else {
					r = afterSize;
				}
			} else {
				r = fontSize;
			}
		} else {
			break;
		}
	}

	[output appendBytes:pos length:r - pos];
	*posRef = r;
}

- (NSData *)consumeData:(NSData *)data {
	[unparsedData appendData:data];
	NSMutableData *output = [[NSMutableData alloc] init];
	if ([unparsedData length] != 0) {
		const char *inputBytes = [unparsedData bytes];
		const char *inputBytesEnd = inputBytes + [unparsedData length];
		const char *pos = inputBytes;
		consume(output, &pos, inputBytesEnd);
		[unparsedData replaceBytesInRange:NSMakeRange(0, pos - inputBytes) withBytes:NULL length:0];
	}
	return [output autorelease];
}
@end
