#import <Foundation/Foundation.h>
#import <CoreData/CoreData.h>

enum PostTrackerPostNovelty { PostTrackerPostNoveltyNew, PostTrackerPostNoveltyNotNew };

@interface PostTracker : NSObject {

	NSManagedObjectModel *managedObjectModel;
	NSManagedObjectContext *managedObjectContext;
	NSPersistentStoreCoordinator *persistentStoreCoordinator;
}


@property (nonatomic, retain, readonly) NSManagedObjectModel *managedObjectModel;
@property (nonatomic, retain, readonly) NSManagedObjectContext *managedObjectContext;
@property (nonatomic, retain, readonly) NSPersistentStoreCoordinator *persistentStoreCoordinator;


- (enum PostTrackerPostNovelty)getPostNovelty:(NSString *)postId inThread:(NSString *)threadId;
- (void)noticePost:(NSString *)itemId inThread:(NSString *)threadId;
- (NSInteger)knownCommentsForThread:(NSString *)threadId;
- (NSString *)applicationDocumentsDirectory;
- (void)applicationWillTerminate:(UIApplication *)application;
- (void)applicationDidEnterBackground:(UIApplication *)application;
- (void)dumpChangesAndCullOldies;
- (BOOL)postInPosts:(NSArray *)array hasPostId:(NSString *)postId;
- (NSArray *)getPostsForPredicate:(NSPredicate *)predicate error:(NSError **)error;
- (NSArray *)getPostsForThread:(NSString *)threadId error:(NSError **)error;
- (NSArray *)getPostsBeforeTime:(NSDate *)date error:(NSError **)error;


+ (PostTracker *)thePostTracker;

@end
