const char *tryProgress(const char *pos, const char *end, const char *s);
const char *skipThroughString(const char **posRef, const char *end, const char *s);
const char *skipAnyWhitespace(const char *pos, const char *end);
const char *eatToOneOf(const char *pos, const char *end, const char *cs);
const char *eatToChar(const char *pos, const char *end, char c);
const char *eatThroughChar(const char *pos, const char *end, char c);
const char *eatSegment(const char *pos, const char *end);
// Returns the address of the beginning of the last segment, modifying *posRef to point
// to the end of the segment.  Returns NULL if unsuccessful, advancing posRef as far as
// it can.
const char *skipThroughSegment(const char **posRef, const char *end, const char *s);
// returns -1 for matching end tags, 0 for other segments, 1 for matching start tags
int segmentTagDirection(const char *beg, const char *end, const char *tagName);
const char *skipThroughCloser(const char **posRef, const char *end, const char *tagName);
const char *skipThroughOpeningTag(const char **posRef, const char *end, const char *tagName);
const char *skipThroughTagWithAttr(const char **posRef, const char *end, const char *tagName, const char *attrString,
                                   const char **attrBegOut, const char **attrEndOut);
const char *choiceTagWithAttr(const char **posRef, const char *end, const char *tagName,
                              const char *attrString_A, const char *attrString_B,
                              const char **attrBegOut, const char **attrEndOut,
                              BOOL *A_wins);
const char *findString(const char *beg, const char *end, const char *s);
BOOL regionEqualsString(const char *beg, const char *end, const char *s);
BOOL isOpeningTag(const char *beg, const char *end, const char *tagName);
const char *stringPrefixWalk(const char *beg, const char *end, const char *s);
BOOL isTagWithAttr(const char *beg, const char *end, const char *tagName, const char *attrString,
                   const char **attrBegOut, const char **attrEndOut);
